EaBIM一直以来积极响应国家“十二五”推进建筑业信息化的号召,对建筑领域的信息技术开展深入技术交流和探讨!致力于打造“BIM-建筑师-生态技术”三位一体综合资源交流共享平台,希望为BIM与可持续设计理念及技术的普及做出微小的贡献!!!

EaBIM

 找回密码
 注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

搜索
查看: 629|回复: 1
打印 上一主题 下一主题

获取墙的一个侧面,并且将上的点坐标转换到XOY面在墙侧面上的坐标系

[复制链接]

1514

主题

7465

帖子

1万

积分

admin

Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10

积分
12404

社区QQ达人

跳转到指定楼层
楼主
发表于 2014-1-15 12:31:13 | 只看该作者 回帖奖励 |倒序浏览 |阅读模式

一个客户问在Revit 2011上如何获得一个墙的侧面,而且把侧面坐标转到XOY平面在墙面上的坐标系。 对于同一个墙(长宽高相同), 任意旋转墙至不同的角度,获取的坐标值是相同的。


我的一篇博客也提到Revit 2012 提供的HostObjUtils类的方法,可以用HostObjUtils.GetSideFaces() 来快速获取侧面。

Revit 2011 没有提供HostObjUtils 类,所以只能是逐个遍历墙上的几何体,面,线。  这个方法在2012,2013仍然适用,不过需要写更多的代码。


下面是完整的一个例子获取选定的墙的侧面,并且获取这个面上的Edge的在XOY是墙面的坐标系下的向量。 另一个看点是如何做坐标转换,演示了如何使用Transform类。


下面是VB代码,这段代码只能针对直线型的墙。

  1. [vb] view plaincopy
  2. Imports Autodesk.Revit.DB  
  3. Imports Autodesk.Revit.UI  
  4. Imports Autodesk.Revit.Attributes  
  5. Imports Autodesk.Revit.ApplicationServices  
  6. Imports Autodesk.Revit.UI.Selection  
  7.   
  8. <TransactionAttribute(Autodesk.Revit.Attributes.TransactionMode.Manual)>  
  9. Public Class CommandName  
  10.     Implements IExternalCommand  
  11.   
  12.     Public Function Execute(ByVal commandData As ExternalCommandData, ByRef message As String, ByVal elements As ElementSet) As Result Implements IExternalCommand.Execute  
  13.         Dim doc As Document  
  14.         doc = commandData.Application.ActiveUIDocument.Document  
  15.         'Pick a wall  
  16.   
  17.         Dim sel As Selection = commandData.Application.ActiveUIDocument.Selection  
  18.         Dim ref1 As Reference = sel.PickObject(ObjectType.Element, "Please pick a wall to get its side face")  
  19.         Dim wall As Wall = ref1.Element  
  20.   
  21.         Dim opt As Options = New Options()  
  22.         opt.View = doc.ActiveView  
  23.   
  24.         Dim obj As GeometryObject  
  25.         Dim solid As Solid  
  26.         Dim face As Face  
  27.         Dim planF As PlanarFace  
  28.   
  29.         Dim wallDirection As XYZ  
  30.         Dim LocationCurve As LocationCurve = wall.Location  
  31.         Dim line As Line = TryCast(LocationCurve.Curve, Line)  
  32.         If (line Is Nothing) Then  
  33.             Return Result.Failed  
  34.         End If  
  35.         wallDirection = line.EndPoint(0) - line.EndPoint(1)  
  36.   
  37.         Dim sideFace As PlanarFace  
  38.   
  39.         Dim transf As Transform  
  40.         'Form a transform, to translate it to the face to the XOY.  
  41.         transf = Transform.Identity  
  42.         transf.BasisX = wallDirection.Normalize()  
  43.         transf.BasisY = wall.Orientation.Normalize()  
  44.         transf.BasisZ = transf.BasisX.CrossProduct(transf.BasisY)  
  45.   
  46.         Dim ptResult1 As XYZ  
  47.         Dim ptResult2 As XYZ  
  48.         Dim pt As XYZ  
  49.         Dim ptString As String = Nothing  
  50.   
  51.         For Each obj In wall.Geometry(opt).Objects  
  52.             If (TypeOf (obj) Is Solid) Then  
  53.                 solid = TryCast(obj, Solid)  
  54.                 'Go through each face  
  55.                 For Each face In solid.Faces  
  56.                     planF = TryCast(face, PlanarFace)  
  57.                     If (Not (planF Is Nothing)) Then  
  58.                         If (planF.Normal.DotProduct(wallDirection) < 0.0001 And Math.Sin(planF.Normal.AngleTo(wall.Orientation)) < 0.001) Then  
  59.                             'get the side face.  
  60.                             sideFace = planF  
  61.                             transf.Origin = sideFace.Origin  
  62.                             'now you can convert the points in the sdie face to the user coordiantes. the result is like it.  
  63.                             For Each edArr As EdgeArray In sideFace.EdgeLoops  
  64.                                 For Each ed As Edge In edArr  
  65.                                     pt = ed.Tessellate()(0)  
  66.                                     ptResult1 = transf.OfPoint(pt)  
  67.                                     pt = ed.Tessellate()(ed.Tessellate().Count - 1)  
  68.                                     ptResult2 = transf.OfPoint(pt)  
  69.                                     ptString += (ptResult1 - ptResult2).X.ToString() + " ; " + (ptResult1 - ptResult2).Y.ToString() + " ; " + (ptResult1 - ptResult2).Z.ToString() + vbCrLf  
  70.   
  71.                                 Next  
  72.                             Next  
  73.                         End If  
  74.                     End If  
  75.                 Next  
  76.             End If  
  77.         Next  
  78.   
  79.         TaskDialog.Show("pts", ptString)  
  80.   
  81.         Return Result.Succeeded  
  82.     End Function  
  83. End Class  
复制代码
显示的结果如下。可以看到墙的角度不同,但是得到的结果是完全一样的。


                               
登录/注册后可看大图


作者:叶雄进文章来源:http://blog.csdn.net/joexiongjin/article/category/782739


分享到:  QQ好友和群QQ好友和群 QQ空间QQ空间 腾讯微博腾讯微博 腾讯朋友腾讯朋友 微信微信
收藏收藏 转播转播 分享分享 分享淘帖 支持支持 反对反对
工作时间:工作日的9:00-12:00/13:30-18:00,节假日不在线,请勿留言
*滑块验证:
您需要登录后才可以回帖 登录 | 注册

本版积分规则

QQ|EaBIM网 ( 苏ICP备2020058923号-1  苏公网安备32011502011255号

GMT+8, 2024-11-23 23:08

Powered by Discuz! X3.2 Licensed

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表